VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ServiceControlManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.

' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source!

' Geschrieben von Florian Rittmeier <florian@activevb.de>
' v0.1 17.01.2004


' Achtung, dieser Code luft erst ab Windows 2000
' da die API-Funktion EnumServicesStatusEx verwendet wird,
' welche laut MSDN Library erst ab dieser Betriebssystemsversion
' verfgbar ist.
'
' Personen, welche die Funktionalitt auch fr Windows NT bentigen,
' mssen sich mit der API EnumServicesStatus befassen.
' Um die notwendigen Informationen abzurufen muss dann des weiteren
' noch die API-Funktion QueryServiceStatus anwenden,
' welche z.B. in der Eigenschaftenprozeduren CanServiceStop verwendet wird


'##################################################################
'           KONSTANTEN fr API-Aufrufe und Rckgabewerte
'##################################################################

' Konstanten fr SC_MANAGER_ALL_ACCESS
Private Const SC_MANAGER_CONNECT As Long = &H1
Private Const SC_MANAGER_CREATE_SERVICE As Long = &H2
Private Const SC_MANAGER_ENUMERATE_SERVICE As Long = &H4
Private Const SC_MANAGER_LOCK As Long = &H8
Private Const SC_MANAGER_MODIFY_BOOT_CONFIG As Long = &H20
Private Const SC_MANAGER_QUERY_LOCK_STATUS As Long = &H10
Private Const STANDARD_RIGHTS_REQUIRED As Long = &HF0000

' Konstante fr OpenSCManager
Private Const SC_MANAGER_ALL_ACCESS As Long = (STANDARD_RIGHTS_REQUIRED Or SC_MANAGER_CONNECT Or SC_MANAGER_CREATE_SERVICE Or SC_MANAGER_ENUMERATE_SERVICE Or SC_MANAGER_LOCK Or SC_MANAGER_QUERY_LOCK_STATUS Or SC_MANAGER_MODIFY_BOOT_CONFIG)

' Konstanten fr EnumServicesStatusEx
Private Const SC_ENUM_PROCESS_INFO As Long = 0
Private Const SERVICES_ACTIVE_DATABASE As String = "ServicesActive"

' Was es an Fehlern auf dieser Welt gibt
Private Const ERROR_ACCESS_DENIED As Long = 5&
Private Const ERROR_DATABASE_DOES_NOT_EXIST As Long = 1065&
Private Const ERROR_INVALID_PARAMETER As Long = 87

Private Const ERROR_INVALID_HANDLE As Long = 6&
Private Const ERROR_INVALID_LEVEL As Long = 124&
Private Const ERROR_MORE_DATA As Long = 234
Private Const ERROR_SHUTDOWN_IN_PROGRESS As Long = 1115&

Private Const ERROR_INSUFFICIENT_BUFFER As Long = 122

' ServiceType
Private Const SERVICE_ACTIVE As Long = &H1
Private Const SERVICE_KERNEL_DRIVER As Long = &H1
Private Const SERVICE_FILE_SYSTEM_DRIVER As Long = &H2
Private Const SERVICE_RECOGNIZER_DRIVER As Long = &H8
Private Const SERVICE_DRIVER As Long = (SERVICE_KERNEL_DRIVER Or SERVICE_FILE_SYSTEM_DRIVER Or SERVICE_RECOGNIZER_DRIVER)
Private Const SERVICE_INACTIVE As Long = &H2
Private Const SERVICE_STATE_ALL As Long = (SERVICE_ACTIVE Or SERVICE_INACTIVE)
Private Const SERVICE_WIN32_OWN_PROCESS As Long = &H10
Private Const SERVICE_WIN32_SHARE_PROCESS As Long = &H20
Private Const SERVICE_WIN32 As Long = (SERVICE_WIN32_OWN_PROCESS Or SERVICE_WIN32_SHARE_PROCESS)
Private Const SERVICE_INTERACTIVE_PROCESS As Long = &H100

' ServiceState
Private Const SERVICE_CONTINUE_PENDING As Long = &H5
Private Const SERVICE_PAUSE_PENDING As Long = &H6
Private Const SERVICE_PAUSED As Long = &H7
Private Const SERVICE_RUNNING As Long = &H4
Private Const SERVICE_START_PENDING As Long = &H2
Private Const SERVICE_STOP_PENDING As Long = &H3
Private Const SERVICE_STOPPED As Long = &H1

' Rechte
Private Const SERVICE_START As Long = &H10
Private Const SERVICE_STOP As Long = &H20
Private Const SERVICE_PAUSE_CONTINUE As Long = &H40
Private Const SERVICE_QUERY_STATUS As Long = &H4

' ServiceFlag
Private Const SERVICE_RUNS_IN_SYSTEM_PROCESS As Long = &H1

' ServiceControl Command
Private Const SERVICE_CONTROL_CONTINUE As Long = &H3
Private Const SERVICE_CONTROL_PAUSE As Long = &H2
Private Const SERVICE_CONTROL_STOP As Long = &H1

' ServiceControlsAccepted
Private Const SERVICE_ACCEPT_PAUSE_CONTINUE As Long = &H2
Private Const SERVICE_ACCEPT_STOP As Long = &H1

' Service Informationen
Private Type SERVICE_STATUS
    dwServiceType As Long
    dwCurrentState As Long
    dwControlsAccepted As Long
    dwWin32ExitCode As Long
    dwServiceSpecificExitCode As Long
    dwCheckPoint As Long
    dwWaitHint As Long
End Type

'########################################################################
'               Deklarationen fr API-Funktionen
'########################################################################

' Verbinung zum SCM herstellen
Private Declare Function OpenSCManager Lib "advapi32.dll" Alias "OpenSCManagerA" ( _
     ByVal lpMachineName As String, _
     ByVal lpDatabaseName As String, _
     ByVal dwDesiredAccess As Long) As Long

' Verbindung zum SCM schlieen und
' alle mglichen anderen Handles schlieen
Private Declare Function CloseServiceHandle Lib "advapi32.dll" ( _
     ByVal hSCObject As Long) As Long

' Enumerieren aller Dienste und gleichzeitiges ermitteln
' weiterer Informationen zu jedem Dienst
' Erst ab Windows 2000 verfgbar
Private Declare Function EnumServicesStatusEx Lib "advapi32.dll" Alias "EnumServicesStatusExA" ( _
     ByVal hSCManager As Long, _
     ByVal InfoLevel As Long, _
     ByVal dwServiceType As Long, _
     ByVal dwServiceState As Long, _
     ByVal lpServices As Long, _
     ByVal cbBufSize As Long, _
     ByVal pcbBytesNeeded As Long, _
     ByVal lpServicesReturned As Long, _
     ByVal lpResumeHandle As Long, _
     ByVal pszGroupName As String) As Long

' Wenn man etwas mit einem Dienst tun mchte, braucht man erst ein Handle
Private Declare Function OpenService Lib "advapi32.dll" Alias "OpenServiceA" ( _
     ByVal hSCManager As Long, _
     ByVal lpServiceName As String, _
     ByVal dwDesiredAccess As Long) As Long

' Starten eines Dienstes
Private Declare Function StartService Lib "advapi32.dll" Alias "StartServiceA" ( _
     ByVal hService As Long, _
     ByVal dwNumServiceArgs As Long, _
     ByVal lpServiceArgVectors As Long) As Long

' Dienst stoppen, anhalten und fortsetzen
Private Declare Function ControlService Lib "advapi32.dll" ( _
     ByVal hService As Long, _
     ByVal dwControl As Long, _
     lpServiceStatus As SERVICE_STATUS) As Long

' Status eines Dienstes abfragen
Private Declare Function QueryServiceStatus Lib "advapi32.dll" ( _
     ByVal hService As Long, _
     lpServiceStatus As SERVICE_STATUS) As Long

' Kopieren eines C-Strings
Private Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" _
        (ByVal lpString1 As Long, ByVal lpString2 As Long) As Long
        
' Lnge eines C-Strings bestimmen
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" _
        (ByVal lpString As Long) As Long
        
' Ein bichen Speicher durch die Gegend schupsen
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
     ByVal Destination As Long, _
     ByVal Source As Long, _
     ByVal Length As Long)
     
' Eigener Behlter fr nen Typen der so nicht so wirklich existiert
Private Type SERVICE_DATA
    ServiceName As String
    DisplayName As String
    ServiceType As Long
    CurrentState As Long
    ControlsAccepted As Long
    Win32ExitCode As Long
    ServiceSpecificExitCode As Long
    CheckPoint As Long
    WaitHint As Long
    ProcessId As Long
    ServiceFlags As Long
End Type

' Handle auf den ServiceControlManager
Private hSCM As Long

' Mglichkeit dem Verwender der Klasse auftretende Fehler mitzuteilen
Public Event Error(ByVal Number As Long, ByVal Description As String)

' Mgliche Fehlercodes und Bedeutung dieser
'
' 1 - Connect - Verbindung besteht bereits
' 2 - Connect - Verbindung konnte nicht aufgebaut werden
' 3 - Disconnect - Verbindung besteht nicht
' 4 - Disconnect - Handle zum SCM konnte nicht geschlossen werden
' 5 - ListServices, InitServiceStart, InitServiceStop, InitServiceStop,
'     InitServicePause, InitServiceContinue, CanServiceStop,
'     CanServicePauseContinue -
'            Es muss eine Verbindung bestehen,
'            damit diese Funktion ausgefhrt
'            werden kann
' 6 - ListServices - Bestimmung der Gre fr die Informationen
'                    zu den Diensten ist fehlgeschlagen
' 7 - ListServices - Liste mit den Diensten konnte nicht abgerufen werden
' 8 - PointerToString - Aufruf von lstrcpy ist fehlgeschlagen
' 9 - InitServiceStart, InitServiceStop, InitServicePause, InitServiceContinue,
'     CanServiceStop, CanServicePauseContinue -
'            es konnte kein Zugriff
'            auf diesen Service erlangt werden
' 10 - InitServiceStart - der Dienst konnte nicht gestartet werden
' 11 - InitServiceStart, InitServiceStop, InitServicePause, InitServiceContinue,
'      CanServiceStop, CanServicePauseContinue -
'            das Handle auf einen Dienst
'            konnte nicht geschlossen werden
' 12 - InitServiceStop - der Dienst konnte nicht beendet werden
' 13 - InitServicePause - der Dienst konnte nicht pausiert werden
' 14 - InitServiceContinue - der Dienst konnte nicht fortgesetzt werden
' 15 - CanServiceStop, CanServicePauseContinue - Status des Dienstes konnte nicht abgefragt werden

' Mglichkeit dem Verwender der Klasse einen genderten Status mitzuteilen
Public Event StatusChange(ByVal Description As String)

Public Property Get IsConnected() As Boolean
IsConnected = CBool(hSCM <> 0)
End Property

Public Sub Connect()
' Verbindet die Instanz mit einem SCM

If IsConnected Then
    RaiseEvent Error(1, "Die Verbindung kann nicht aufgebaut werden, " & _
                            "da sie schon besteht.")
    Exit Sub
End If

Dim errorstring As String
Dim retval As Long

' Zu lokalen SCM mit allen Rechten verbinden.
' TODO: Das sind relativ sicher mehr Rechte
'       als es eigentlich braucht. Das sollte
'       bei Gelegenheit gendert werden.
retval = OpenSCManager(vbNullString, _
                        SERVICES_ACTIVE_DATABASE, _
                        SC_MANAGER_ALL_ACCESS)

' Fehlerbehandlung
If retval = 0 Then
    retval = Err.LastDllError
    
    ' passende Fehlermeldung raussuchen
    If retval = ERROR_ACCESS_DENIED Then
        errorstring = "Der angeforderte Zugang wurde verweigert," & vbCrLf & _
                        "da die notwendigen Rechte/Privilegien " & _
                        "nicht vorhanden sind."
    ElseIf retval = ERROR_DATABASE_DOES_NOT_EXIST Then
        errorstring = "Die zu ffnende Datenbank existiert nicht."
    ElseIf retval = ERROR_INVALID_PARAMETER Then
        errorstring = "Einer der angegebenen Parameter ist ungltig."
    Else
        errorstring = "Der Grund dafr wurde nicht genauer abgefragt."
    End If
    
    ' Fehler melden
    RaiseEvent Error(2, "Die Verbindung konnte nicht geffnet werden." & _
                    vbCrLf & errorstring)
    Exit Sub
End If

' Alles gut gegangen - Handle sichern
hSCM = retval

RaiseEvent StatusChange("Zum SCM verbunden")
End Sub
Public Sub Disconnect()
' Verbindung zum SCM beenden

If Not IsConnected Then
    RaiseEvent Error(3, "Die Verbindung kann nicht geschlossen werden, da sie nicht besteht.")
    Exit Sub
End If

Dim retval As Long
retval = CloseServiceHandle(hSCM)

If retval = 0 Then
    RaiseEvent Error(4, "Das SCM-Handle konnte nicht geschlossen werden!")
    ' TODO: Erweiterte Fehlermeldung generieren
    '       ber Err.LastDllError abfragen und auswerten
    Exit Sub
End If

' Alles in Ordnung - Handle auf Null setzen
hSCM = 0

RaiseEvent StatusChange("Nicht mehr zum SCM verbunden")
End Sub
Public Sub ListServices(fg As MSFlexGrid)
' Gibt alle Dienste und einige Informationen zu diesen
' in einem MSFlexGrid-Steuerelement auf.
'
' Luft nur ab Windows 2000

If Not IsConnected Then
    RaiseEvent Error(5, "Es muss zunchste eine Verbindung " & _
                    "zum SCM aufgebaut werden, " & vbCrLf & _
                    "bevor diese Operation ausgefhrt werden kann.")
    Exit Sub
End If

Dim retval As Long ' API-Rckgabewerte

Dim bytedata() As Byte ' Einige Daten die wir spter umkopieren
Dim bdlength As Long ' Anzahl der Bytes in bytedata()

' Anzahl der Bytes die bentigt werden um alle Daten abzuspeichern
Dim bytesneeded As Long
' Anzahl der Services zu denen Informationen zurck geliefert werden
Dim serviceentriestreturned As Long
' Soll angeben, welche Informationen noch nicht kopiert werden konnten
Dim resumehandle As Long

' Zur Verdeutlichung, dass resumehandle bei diesem Aufruf Null sein muss
resumehandle = 0

' Wir rufen EnumServicesStatusEx zunchst auf,
' um zu bestimmten wieviel Platz wir fr die Daten reservieren mssen.

' Wir wollen nur die Dienste die keine Kernel- oder Dateisystemtreiber sind
retval = EnumServicesStatusEx(hSCM, SC_ENUM_PROCESS_INFO, _
                                SERVICE_WIN32, _
                                SERVICE_STATE_ALL, _
                                0, _
                                0, _
                                VarPtr(bytesneeded), _
                                VarPtr(serviceentriestreturned), _
                                VarPtr(resumehandle), _
                                vbNullString)

If retval = 0 And Err.LastDllError = ERROR_MORE_DATA Then
    ' Wir knnen anhand der in bytesneeded abgelegten Lnge
    ' den notwendigen Platz reservieren
    ReDim bytedata(0 To (bytesneeded - 1))
    bdlength = bytesneeded
    bytesneeded = 0
Else
    RaiseEvent Error(6, "Bei der Abfrage der notwendigen Speichergre " & _
                "ist ein Fehler aufgetreten.")
    Exit Sub
End If

' Zurcksetzen diese beiden Variablen um nun die Daten abzurufen
serviceentriestreturned = 0
resumehandle = 0

' Abruf der Daten wie oben, nur mit bergabe der Adresse
' des Speicherortes und Lnge dieses
retval = EnumServicesStatusEx(hSCM, SC_ENUM_PROCESS_INFO, _
                                SERVICE_WIN32, _
                                SERVICE_STATE_ALL, _
                                 VarPtr(bytedata(0)), _
                                 bdlength, _
                                VarPtr(bytesneeded), _
                                VarPtr(serviceentriestreturned), _
                                VarPtr(resumehandle), _
                                vbNullString)
                                
If retval = 0 Then
    RaiseEvent Error(7, "Das Abrufen der Liste der Dienste ist fehlgeschlagen.")
    Exit Sub
End If
                              
'(serviceentriestreturned * 4 * 11) von bdlength
                                
Dim i As Long
Dim flexindex As Long ' Indexvariable die mehrere Subs gemeinsam bentigen
Dim sd As SERVICE_DATA
Dim Address As Long ' Startadresse des Speichers mit den Informationen
Address = VarPtr(bytedata(0))

' FlexGrid leeren und Spaltenkpfe beschriften
ClearServiceList fg, flexindex

' alle Informationspakete durchgehen und Daten zum FlexGrid hinzufgen
For i = 0 To serviceentriestreturned - 1
    ' Umwandlung der Daten ab der Adresse Address
    ' in einen UDT vom Typ SERVICE_DATA
    sd = PointerToServiceData(Address)
    ' Darstellung dieser Daten im FlexGrif
    AddItemToServiceList sd, fg, flexindex
    ' neue Adresse berechnen
    Address = Address + 4 * 11
Next
                                
RaiseEvent StatusChange("FlexGrid aktualisiert")
End Sub

Public Sub InitServiceStart(ByVal ServiceName As String)
' Versucht einen Dienst zu starten.

' Es wird aber sichergestellt, dass der Dienst
' bei der Rckkehr dieser Methode bereit luft.
' In der Regel wird er noch im Status 'START_PENDING' hngen

If Not IsConnected Then
    RaiseEvent Error(5, "Es muss zunchste eine Verbindung " & _
                    "zum SCM aufgebaut werden, " & vbCrLf & _
                    "bevor diese Operation ausgefhrt werden kann.")
    Exit Sub
End If

Dim retval As Long
' Handle auf Dienst besorgen
retval = OpenService(hSCM, ServiceName, SERVICE_START)

If retval = 0 Then
    RaiseEvent Error(9, "Der Zugriff auf den Dienst konnte nicht erlangt werden.")
    Exit Sub
End If

' Alles in Ordnung
Dim hService As Long
hService = retval ' Sichern des Handles

' Versuch den Dienst zu starten
retval = StartService(hService, 0, 0)

If retval = 0 Then
    RaiseEvent Error(10, "Der Dienst konnte nicht gestartet werden.")
    
    retval = CloseServiceHandle(hService)
    If retval = 0 Then
        ' Falls der Handle nicht geschlossen werden konnte, den Nutzer
        ' auch darber informieren
        RaiseEvent Error(11, "Das Handle auf den Dienst konnte nicht geschlossen werden!")
    End If
    
    Exit Sub
End If

' Dienst wurde erfolgreich "angeworfen".
' Ob der Dienst wirklich luft, wird nicht berprft,
' da dies lngere Zeit dauern kann.

retval = CloseServiceHandle(hService)

If retval = 0 Then
    ' Falls der Handle nicht geschlossen werden konnte, den Nutzer
    ' auch darber informieren
    RaiseEvent Error(11, "Das Handle auf den Dienst konnte nicht geschlossen werden!")
End If

RaiseEvent StatusChange("Der angegebene Dienst startet nun.")
End Sub
Public Sub InitServiceStop(ByVal ServiceName As String)
' Versucht einen Dienst zu stoppen

' Mit der Rckkehr der Methode ist nicht gesagt,
' dass der Dienst wirklich gestoppt hat

If Not IsConnected Then
    RaiseEvent Error(5, "Es muss zunchste eine Verbindung " & _
                    "zum SCM aufgebaut werden, " & vbCrLf & _
                    "bevor diese Operation ausgefhrt werden kann.")
    Exit Sub
End If

Dim retval As Long
' Handle auf den Dienst erlangen
retval = OpenService(hSCM, ServiceName, SERVICE_STOP)

If retval = 0 Then
    RaiseEvent Error(9, "Der Zugriff auf den Dienst konnte nicht erlangt werden.")
    Exit Sub
End If

' Alles in Ordnung
Dim hService As Long
hService = retval ' Handle sichern

Dim lpss As SERVICE_STATUS

' Kommando an den Dienst schicken
retval = ControlService(hService, SERVICE_CONTROL_STOP, lpss)

If retval = 0 Then
    RaiseEvent Error(12, "Der Dienst konnte nicht gestoppt werden.")
    
    retval = CloseServiceHandle(hService)
    If retval = 0 Then
        ' Falls der Handle nicht geschlossen werden konnte, den Nutzer
        ' auch darber informieren
        RaiseEvent Error(11, "Das Handle auf den Dienst konnte nicht geschlossen werden!")
    End If
    
    Exit Sub
End If

' Alles In Ordnung
retval = CloseServiceHandle(hService)

If retval = 0 Then
    ' Falls der Handle nicht geschlossen werden konnte, den Nutzer
    ' auch darber informieren
    RaiseEvent Error(11, "Das Handle auf den Dienst konnte nicht geschlossen werden!")
End If

RaiseEvent StatusChange("Der angegebene Dienst stoppt nun.")
End Sub
Public Sub InitServicePause(ByVal ServiceName As String)
' Versucht einen Dienst anzuhalten/zu pausieren

' Mit der Rckkehr der Methode ist nicht gesagt,
' das der Dienst wirklich schon angehalten ist.

If Not IsConnected Then
    RaiseEvent Error(5, "Es muss zunchste eine Verbindung " & _
                    "zum SCM aufgebaut werden, " & vbCrLf & _
                    "bevor diese Operation ausgefhrt werden kann.")
    Exit Sub
End If

Dim retval As Long
' Ein Handle auf den Dienst erlangen
retval = OpenService(hSCM, ServiceName, SERVICE_PAUSE_CONTINUE)

If retval = 0 Then
    RaiseEvent Error(9, "Der Zugriff auf den Dienst konnte nicht erlangt werden.")
    Exit Sub
End If

' Alles in Ordnung
Dim hService As Long
hService = retval

Dim lpss As SERVICE_STATUS

' Dem Dienst das entsprechende Kommando schicken
retval = ControlService(hService, SERVICE_CONTROL_PAUSE, lpss)

If retval = 0 Then
    RaiseEvent Error(13, "Der Dienst konnte nicht pausiert werden.")
    
    retval = CloseServiceHandle(hService)
    If retval = 0 Then
        ' Falls der Handle nicht geschlossen werden konnte, den Nutzer
        ' auch darber informieren
        RaiseEvent Error(11, "Das Handle auf den Dienst konnte nicht geschlossen werden!")
    End If
    
    Exit Sub
End If

' Alles In Ordnung
retval = CloseServiceHandle(hService)

If retval = 0 Then
    ' Falls der Handle nicht geschlossen werden konnte, den Nutzer
    ' auch darber informieren
    RaiseEvent Error(11, "Das Handle auf den Dienst konnte nicht geschlossen werden!")
End If

RaiseEvent StatusChange("Der angegebene Dienst versucht nun zu pausieren.")
End Sub
Public Sub InitServiceContinue(ByVal ServiceName As String)
' Versucht einen Dienst fortzusetzen

' Mit der Rckkehr des Dienstes ist nicht gesagt,
' dass der Dienst wirklich schon wieder luft.

If Not IsConnected Then
    RaiseEvent Error(5, "Es muss zunchste eine Verbindung " & _
                    "zum SCM aufgebaut werden, " & vbCrLf & _
                    "bevor diese Operation ausgefhrt werden kann.")
    Exit Sub
End If

Dim retval As Long
retval = OpenService(hSCM, ServiceName, SERVICE_PAUSE_CONTINUE)

If retval = 0 Then
    RaiseEvent Error(9, "Der Zugriff auf den Dienst konnte nicht erlangt werden.")
    Exit Sub
End If

' Alles in Ordnung
Dim hService As Long
hService = retval

Dim lpss As SERVICE_STATUS

' Dem Dienst das entsprechende Kommando schicken
retval = ControlService(hService, SERVICE_CONTROL_CONTINUE, lpss)

If retval = 0 Then
    RaiseEvent Error(14, "Der Dienst konnte nicht fortgesetzt werden.")
    
    retval = CloseServiceHandle(hService)
    If retval = 0 Then
        ' Falls der Handle nicht geschlossen werden konnte, den Nutzer
        ' auch darber informieren
        RaiseEvent Error(11, "Das Handle auf den Dienst konnte nicht geschlossen werden!")
    End If
    
    Exit Sub
End If

' Alles In Ordnung
retval = CloseServiceHandle(hService)

If retval = 0 Then
    ' Falls der Handle nicht geschlossen werden konnte, den Nutzer
    ' auch darber informieren
    RaiseEvent Error(11, "Das Handle auf den Dienst konnte nicht geschlossen werden!")
End If

RaiseEvent StatusChange("Der angegebene Dienst versucht nun fortzusetzen.")
End Sub
Public Property Get CanServiceStop(ByVal ServiceName As String) As Boolean
' Feststellen, ob ein Dienst gestoppt werden kann

If Not IsConnected Then
    RaiseEvent Error(5, "Es muss zunchste eine Verbindung " & _
                    "zum SCM aufgebaut werden, " & vbCrLf & _
                    "bevor diese Operation ausgefhrt werden kann.")
    Exit Sub
End If

Dim retval As Long
' Ein handle auf den Dienst erlangen
retval = OpenService(hSCM, ServiceName, SERVICE_QUERY_STATUS)

If retval = 0 Then
    RaiseEvent Error(9, "Der Zugriff auf den Dienst konnte nicht erlangt werden.")
    Exit Sub
End If

' Alles in Ordnung
Dim hService As Long
hService = retval

Dim lpss As SERVICE_STATUS

' Den Status des Dienstes abfragen
retval = QueryServiceStatus(hService, lpss)

If retval = 0 Then
    RaiseEvent Error(15, "Der Status des Dienstes konnte nicht abgefragt werden.")
    
    retval = CloseServiceHandle(hService)
    If retval = 0 Then
        ' Falls der Handle nicht geschlossen werden konnte, den Nutzer
        ' auch darber informieren
        RaiseEvent Error(11, "Das Handle auf den Dienst konnte nicht geschlossen werden!")
    End If
    
    Exit Sub
End If

' Alles In Ordnung
retval = CloseServiceHandle(hService)

If retval = 0 Then
    ' Falls der Handle nicht geschlossen werden konnte, den Nutzer
    ' auch darber informieren
    RaiseEvent Error(11, "Das Handle auf den Dienst konnte nicht geschlossen werden!")
End If

CanServiceStop = ((lpss.dwControlsAccepted And SERVICE_ACCEPT_STOP) = SERVICE_ACCEPT_STOP)
End Property
Public Property Get CanServicePauseContinue(ByVal ServiceName As String) As Boolean
If Not IsConnected Then
    RaiseEvent Error(5, "Es muss zunchste eine Verbindung " & _
                    "zum SCM aufgebaut werden, " & vbCrLf & _
                    "bevor diese Operation ausgefhrt werden kann.")
    Exit Property
End If

Dim retval As Long
retval = OpenService(hSCM, ServiceName, SERVICE_QUERY_STATUS)

If retval = 0 Then
    RaiseEvent Error(9, "Der Zugriff auf den Dienst konnte nicht erlangt werden.")
    Exit Property
End If

' Alles in Ordnung
Dim hService As Long
hService = retval ' Handle sichern

Dim lpss As SERVICE_STATUS

' Den Status des Dienstes abfragen
retval = QueryServiceStatus(hService, lpss)

If retval = 0 Then
    RaiseEvent Error(15, "Der Status des Dienstes konnte nicht abgefragt werden.")
    
    retval = CloseServiceHandle(hService)
    If retval = 0 Then
        ' Falls der Handle nicht geschlossen werden konnte, den Nutzer
        ' auch darber informieren
        RaiseEvent Error(11, "Das Handle auf den Dienst konnte nicht geschlossen werden!")
    End If
    
    Exit Property
End If

' Alles In Ordnung
retval = CloseServiceHandle(hService)

If retval = 0 Then
    ' Falls der Handle nicht geschlossen werden konnte, den Nutzer
    ' auch darber informieren
    RaiseEvent Error(11, "Das Handle auf den Dienst konnte nicht geschlossen werden!")
End If

CanServicePauseContinue = _
    ((lpss.dwControlsAccepted And SERVICE_ACCEPT_PAUSE_CONTINUE) = _
        SERVICE_ACCEPT_PAUSE_CONTINUE)
End Property

'###############################################################
'               Von ListServices verwendte Funktionen
'###############################################################

Private Sub ClearServiceList(fg As MSFlexGrid, ByRef flexindex As Long)
flexindex = 1 ' gemeinsamer Index zurcksetzen

' Anzahl der Spalten- bzw. Reihenkpfe festlegen
fg.FixedCols = 0
fg.FixedRows = 1

' Minimalanzahl der Zeilen setzen
fg.Rows = 2
fg.Cols = 5 '11


' Spaltenkpfe beschriften
fg.TextMatrix(0, 0) = "ServiceName"
fg.TextMatrix(0, 1) = "DisplayName"
fg.TextMatrix(0, 2) = "ServiceType"
fg.TextMatrix(0, 3) = "CurrentState"
fg.TextMatrix(0, 4) = "ProcessId"
'fg.TextMatrix(0, 5) = "ControlsAccepted"
'fg.TextMatrix(0, 6) = "Win32ExitCode"
'fg.TextMatrix(0, 7) = "ServiceSpecificExitCode"
'fg.TextMatrix(0, 8) = "CheckPoint"
'fg.TextMatrix(0, 9) = "WaitHint"
'fg.TextMatrix(0, 10) = "ServiceFlags"

' Minimalbreite setzen = Breite des jeweiligen Spaltenkopfes
Dim i As Long, bw As Long
bw = fg.Parent.TextWidth(Space(2))

For i = 0 To 4
fg.ColWidth(0) = fg.Parent.TextWidth(fg.TextMatrix(0, i)) + bw
Next

' Eintrge der ersten Datenzeile zurcksetzen
For i = 0 To fg.Cols - 1
    fg.TextMatrix(flexindex, i) = ""
Next

' Ausrichtung der Spalte mit den ProzessIds festlegen
fg.ColAlignment(4) = flexAlignRightCenter
End Sub
Private Sub AddItemToServiceList(sd As SERVICE_DATA, fg As MSFlexGrid, ByRef flexindex As Long)
' Hinzufgen der Daten eines Eintrages

' Anzahl der Reihen anpassen
If fg.Rows < flexindex + 1 Then fg.Rows = flexindex + 1

' Setzen und z.T. konvertieren der Informationen

fg.TextMatrix(flexindex, 0) = sd.ServiceName
fg.TextMatrix(flexindex, 1) = sd.DisplayName
fg.TextMatrix(flexindex, 2) = ServiceTypeToString(sd.ServiceType)
fg.TextMatrix(flexindex, 3) = CurrentStateToString(sd.CurrentState)
fg.TextMatrix(flexindex, 4) = ProcessIdToString(sd.ProcessId, sd.ServiceFlags)
'fg.TextMatrix(flexindex, 5) = sd.ControlsAccepted
'fg.TextMatrix(flexindex, 6) = sd.Win32ExitCode
'fg.TextMatrix(flexindex, 7) = sd.ServiceSpecificExitCode
'fg.TextMatrix(flexindex, 8) = sd.CheckPoint
'fg.TextMatrix(flexindex, 9) = sd.WaitHint
'fg.TextMatrix(flexindex, 10) = sd.ServiceFlags

' Minimalbreite falls notwendig anpassen
Dim bw As Long
bw = fg.Parent.TextWidth(Space(2))

Dim i As Long
For i = 0 To 4
    If fg.ColWidth(i) < fg.Parent.TextWidth(fg.TextMatrix(flexindex, i)) + bw Then
        fg.ColWidth(i) = fg.Parent.TextWidth(fg.TextMatrix(flexindex, i)) + bw
    End If
Next

flexindex = flexindex + 1
End Sub

'###############################################################
'           einige Low-Level-Funktionen
'###############################################################

Private Function PointerToString(ByVal Address As Long) As String
' Kopiert einen C-String (angegeben ber eine Adresse)
' in einen VB-String

Dim data() As Byte
Dim l As Long
l = lstrlen(Address) + 1

ReDim data(0 To (l - 1))

If lstrcpy(VarPtr(data(0)), Address) = 0 Then
    RaiseEvent Error(8, "Aufruf von lstrcpy fehlgeschlagen.")
    Exit Function
End If

PointerToString = Trim(StrConv(data, vbUnicode))
End Function
Private Function CopyBytesToLong(ByVal Address As Long) As Long
' Kopiert die vier Bytes nach einer angegebenen Adresse
' in eine Variable vom Typ Long

Dim l As Long
Call CopyMemory(VarPtr(l), Address, 4)

CopyBytesToLong = l
End Function
Private Function PointerToServiceData(ByVal Address As Long) As SERVICE_DATA
' Kopiert die Daten ab einer bestimmten Adresse in eine
' Variable vom UDT SERVICE_DATA

Dim sd As SERVICE_DATA

sd.ServiceName = PointerToString(CopyBytesToLong(Address))
sd.DisplayName = PointerToString(CopyBytesToLong(Address + 4))

Call CopyMemory(VarPtr(sd.ServiceType), Address + 8, 9 * 4)

PointerToServiceData = sd
End Function

'###############################################################
'    Funktionen um Daten aus einem UDT des Typs SERVICE_DATA
'               in eine lesbare Form zu bringen
'###############################################################

Private Function CurrentStateToString(ByVal cs As Long) As String
Dim s As String

If cs = SERVICE_STOPPED Then
    s = "gestoppt"
ElseIf cs = SERVICE_START_PENDING Then
    s = "versucht zu starten"
ElseIf cs = SERVICE_STOP_PENDING Then
    s = "versucht zu stoppen"
ElseIf cs = SERVICE_RUNNING Then
    s = "luft"
ElseIf cs = SERVICE_CONTINUE_PENDING Then
    s = "versucht fortzufahren"
ElseIf cs = SERVICE_PAUSE_PENDING Then
    s = "versucht zu pausieren"
ElseIf cs = SERVICE_PAUSED Then
    s = "pausiert"
Else
    s = "Nicht bekannter Status"
End If

CurrentStateToString = s
End Function

Private Function ServiceTypeToString(ByVal st As Long) As String
Dim s As String

If st = SERVICE_FILE_SYSTEM_DRIVER Then
    s = "Dateisystemtreiber"
ElseIf st = SERVICE_KERNEL_DRIVER Then
    s = "Gertetreiber"
ElseIf (st And SERVICE_WIN32_OWN_PROCESS) = SERVICE_WIN32_OWN_PROCESS Then
    If (st And SERVICE_INTERACTIVE_PROCESS) = SERVICE_INTERACTIVE_PROCESS Then
        s = "Interaktiv in eigenem Prozess"
    Else
        s = "in eigenem Prozess"
    End If
ElseIf (st And SERVICE_WIN32_SHARE_PROCESS) = SERVICE_WIN32_SHARE_PROCESS Then
    If (st And SERVICE_INTERACTIVE_PROCESS) = SERVICE_INTERACTIVE_PROCESS Then
        s = "Interaktiv in gemeinsamen Prozess"
    Else
        s = "in gemeinsamen Prozess"
    End If
Else
    s = "unbekannter Diensttyp"
End If

ServiceTypeToString = s
End Function

Private Function ProcessIdToString(ByVal pid As Long, ByVal ServiceFlags As Long) As String
If ServiceFlags = SERVICE_RUNS_IN_SYSTEM_PROCESS Then
    ' Bedeutet, dass dies ein Systemdienst ist, der immer laufen muss
    ProcessIdToString = "SYSTEM"
ElseIf ServiceFlags = 0 Then
    If pid = 0 Then
        ProcessIdToString = "keine"
    Else
        ProcessIdToString = pid
    End If
Else
    ProcessIdToString = "Unbekannt (" & pid & ")"
End If
End Function

Private Sub Class_Terminate()
If IsConnected Then Disconnect
End Sub
